'
' PB File type include file - Public Domain by Borje Hagsten, January 2002.
'
' Totally self-redrawing via container window. Use as ordinary
' combox to get selected item's text, etc.
'
' LOG:
' Jan 14, 2003: Changed handles to DWORD and now use GetSystemMetrics
'               to ensure item height = small icon if big font is set.
'               It now uses GetWindowLong(hWnd, %GWL_HINSTANCE) to
'               get proper instance handle at creation.
'
%DCM_SETFTYPESEL3DFACE = 7000 ' wParam sets custom sel color, lParam decides redraw
'--------------------------------------------------------------------
DECLARE FUNCTION FileTypeCBProc(BYVAL hWnd   AS DWORD, BYVAL wMsg   AS DWORD, _
                                BYVAL wParam AS LONG, BYVAL lParam AS LONG) AS LONG
DECLARE FUNCTION ftCBcontainerProc(BYVAL hWnd   AS DWORD, BYVAL wMsg   AS DWORD,_
                                   BYVAL wParam AS LONG, BYVAL lParam AS LONG) AS LONG

'
' Create PB File type Combobox
'
FUNCTION CreatePBFileTypeCB ALIAS "CreatePBFileTypeCB" _
                           (BYVAL hWnd AS DWORD, BYVAL CtrlId AS LONG, _
                            BYVAL vLeft AS LONG, BYVAL vTop AS LONG, _
                            BYVAL vWidth AS LONG, BYVAL vHeight AS LONG, _
                            BYVAL DDTstyle AS LONG) EXPORT AS DWORD

  LOCAL hParent AS DWORD, hCombo AS DWORD, oldCBFileTypeProc AS DWORD
  LOCAL wc      AS WNDCLASSEX, szClassName AS ASCIIZ * 20, rc AS RECT

  'REGISTER A CUSTOM CONTROL CLASS FOR CONTAINER WINDOW
  szClassName      = "PBFILETYPECB"
  wc.cbSize        = LEN(wc)
  wc.lpfnWndProc   = CODEPTR(ftCBcontainerProc)
  wc.cbWndExtra    = 8
  wc.hInstance     = GetWindowLong(hWnd, %GWL_HINSTANCE)
  wc.lpszClassName = VARPTR(szClassName)

  RegisterClassEx wc

  IF DDTstyle THEN
     DIALOG UNITS hWnd, vLeft, vTop TO PIXELS vLeft, vTop
     DIALOG UNITS hWnd, vWidth, vHeight TO PIXELS vWidth, vHeight
  END IF

  'create container window, for redrawing operations in wm_drawitem
  hParent = CreateWindowEx(%WS_EX_CONTROLPARENT, "PBFILETYPECB", BYVAL 0, %WS_VISIBLE OR %WS_CHILD, _
                           vLeft, vTop, vWidth, vHeight, _
                           hwnd, CtrlId, wc.hInstance, BYVAL 0)

  IF hParent THEN 'create ownerdrawn combobox
     hCombo = CreateWindowEx(%WS_EX_CLIENTEDGE, "COMBOBOX", BYVAL 0, %WS_VISIBLE OR _
                             %WS_CHILD OR %WS_VISIBLE OR %CBS_OWNERDRAWFIXED OR %CBS_HASSTRINGS OR _
                             %CBS_DROPDOWNLIST OR %WS_TABSTOP OR %WS_VSCROLL, _
                             0, 0, vWidth, vHeight, _
                             hParent, CtrlId, wc.hInstance, BYVAL 0)
  ELSE
     EXIT FUNCTION 'return zero on failure
  END IF

  IF hCombo THEN
     'set a proper ansi variable font, usually MS Sans Serif..
     SendMessage hCombo, %WM_SETFONT, GetStockObject(%ANSI_VAR_FONT), 0

     'ensure item height is at least small icon (caption icon) height
     SendMessage hCombo, %CB_SETITEMHEIGHT, 0, GetSystemMetrics(%SM_CYSMICON) + 3

     GetWindowRect hCombo, rc 'must resize parent to actual combobox size
     SetWindowPos hParent, 0, 0, 0, rc.nRight - rc.nLeft, _
                   rc.nBottom - rc.nTop, %SWP_NOMOVE OR %SWP_NOZORDER

     'Subclass control and store pointer to old procedure in parent's cbWndExtra
     oldCBFileTypeProc = SetWindowLong(hCombo, %GWL_WNDPROC, BYVAL CODEPTR(FileTypeCBProc))
     IF oldCBFileTypeProc THEN SetWindowLong hParent, 0, oldCBFileTypeProc
  END IF

  FUNCTION = hCombo 'return the handle of combobox
END FUNCTION

'
' Container procedure
'
FUNCTION ftCBcontainerProc(BYVAL hWnd   AS DWORD, BYVAL wMsg   AS DWORD,_
                           BYVAL wParam AS LONG, BYVAL lParam AS LONG) AS LONG
  SELECT CASE wMsg
     CASE %WM_SETFOCUS
        IF wParam <> GetWindow(hWnd, %GW_CHILD) THEN
           SetFocus GetWindow(hWnd, %GW_CHILD)  'Move focus to child combo
        END IF
        FUNCTION = 0 : EXIT FUNCTION

     CASE %WM_DRAWITEM, %WM_COMPAREITEM 'pass these on to control
        SendMessage GetDlgItem(hWnd, wParam), wMsg, wParam, lParam
        FUNCTION = %TRUE : EXIT FUNCTION

     CASE %WM_COMMAND  'pass these on to child combo
         '-----------------------------------------
        LOCAL hFType AS DWORD
        hFType = GetWindow(hWnd, %GW_CHILD)

        'avoid re-select of last selected item if mouse is clicked outside list
        IF hFType AND HIWRD(wParam) = %CBN_SELENDOK THEN
           LOCAL itemCount AS LONG, itemHeight AS LONG, visItems AS LONG, _
                 rc AS RECT, rc2 AS RECT, pt AS POINTAPI
           GetCursorPos pt
           GetWindowRect hFType, rc2
           itemCount  = SendMessage(hFType, %CB_GETCOUNT, 0, 0)
           itemHeight = SendMessage(hFType, %CB_GETITEMHEIGHT, 0, 0)
           SendMessage hFType, %CB_GETDROPPEDCONTROLRECT, 0, VARPTR(rc)

           rc.nTop    = rc.nTop + rc2.nBottom - rc2.nTop
           visItems   = MIN&(itemCount, (rc.nBottom - rc.nTop) \ itemHeight)
           rc.nBottom = rc.nTop + visItems * itemHeight

           IF ((GetKeyState(%VK_RETURN) AND &H8000) = 0 AND PtInRect(rc, pt.x, pt.y) = 0) OR _
                 (GetKeyState(%VK_ESCAPE) AND &H8000) THEN
              EXIT FUNCTION
           END IF
        END IF
         '-----------------------------------------
        IF lParam <> 0 THEN SendMessage GetParent(hWnd), wMsg, wParam, lParam
        FUNCTION = 0 : EXIT FUNCTION

  END SELECT
  FUNCTION = DefWindowProc(hWnd, wMsg, wParam, lParam) 'default message processing
END FUNCTION

'
' Subclassed Combobox procedure
'
FUNCTION FileTypeCBProc(BYVAL hWnd   AS DWORD, BYVAL wMsg   AS DWORD, _
                        BYVAL wParam AS LONG, BYVAL lParam AS LONG) AS LONG
  LOCAL oldCBFileTypeProc AS LONG
  oldCBFileTypeProc = GetWindowLong(GetParent(hWnd), 0)

  SELECT CASE wMsg
     CASE %DCM_SETFTYPESEL3DFACE 'select selection color scheme
        SetWindowLong GetParent(hWnd),  4, wParam
        IF lParam THEN
           InvalidateRect hWnd, BYVAL %NULL, 0
           UpdateWindow hWnd
        END IF

     CASE %WM_DESTROY 'Un-subclass Combobox when it's detroyed
        IF oldCBFileTypeProc THEN SetWindowLong hWnd, %GWL_WNDPROC, oldCBFileTypeProc

     CASE %WM_DRAWITEM
        LOCAL lpdis AS DRAWITEMSTRUCT PTR
        lpdis = lParam
        IF @lpdis.itemID = &HFFFFFFFF& THEN EXIT FUNCTION

        SELECT CASE @lpdis.itemAction
           CASE %ODA_DRAWENTIRE, %ODA_SELECT
              LOCAL y AS LONG, selCol AS LONG, TextDrawFlag AS DWORD, IconDrawFlag AS DWORD
              LOCAL hcIco AS DWORD, tm AS TEXTMETRIC, zTxt AS ASCIIZ * %MAX_PATH
              TextDrawFlag = &H2  ' DST_PREFIXTEXT
              IconDrawFlag = &H3  ' DST_ICON
              selCol = GetWindowLong(GetParent(hWnd), 4) 'is control set for custom sel color?
 
              'CLEAR BACKGROUND
              IF IsWindowEnabled(hWnd) THEN                           'ENABLED CONTROL
                 IF (@lpdis.itemState AND %ODS_SELECTED) = 0 OR _     'if not selected
                       (@lpdis.itemState AND &H1000) THEN             'or is %ODS_COMBOBOXEDIT part
                    FillRect @lpdis.hDC, @lpdis.rcItem, GetSysColorBrush(%COLOR_WINDOW) 'clear background
                    SetBkColor @lpdis.hDC, GetSysColor(%COLOR_WINDOW)        'text background
                    SetTextColor @lpdis.hDC, GetSysColor(%COLOR_WINDOWTEXT)  'text color
                 ELSE
                    IF selCol THEN 'control is set to use custom sel color
                       FillRect @lpdis.hDC, @lpdis.rcItem, GetSysColorBrush(%COLOR_3DFACE) 'clear background
                       SetBkColor @lpdis.hDC, GetSysColor(%COLOR_3DFACE)     'text background
                       SetTextColor @lpdis.hDC, GetSysColor(%COLOR_BTNTEXT)  'text color
                    ELSE
                       FillRect @lpdis.hDC, @lpdis.rcItem, GetSysColorBrush(%COLOR_HIGHLIGHT) 'clear background
                       SetBkColor @lpdis.hDC, GetSysColor(%COLOR_HIGHLIGHT)        'text background
                       SetTextColor @lpdis.hDC, GetSysColor(%COLOR_HIGHLIGHTTEXT)  'text color
                    END IF
                 END IF
 
              ELSE                                                        'DISABLED CONTROL
                 FillRect @lpdis.hDC, @lpdis.rcItem, GetSysColorBrush(%COLOR_3DFACE) 'clear background
                 SetBkColor @lpdis.hDC, GetSysColor(%COLOR_3DFACE)        'text background
                 SetTextColor @lpdis.hDC, GetSysColor(%COLOR_WINDOWTEXT)  'text color
                 TextDrawFlag = TextDrawFlag OR &H20 ' DSS_DISABLED
                 IconDrawFlag = IconDrawFlag OR &H20 ' DSS_DISABLED
              END IF

              'CALCULATE CENTERED Y POS
              GetTextMetrics @lpdis.hDC, tm  'get font size
              y = (@lpdis.rcItem.nBottom + @lpdis.rcItem.nTop - tm.tmHeight) / 2 'center text

              'GET/DRAW TEXT
              SendMessage hWnd, %CB_GETLBTEXT, @lpdis.itemID, VARPTR(zTxt)
              DrawState @lpdis.hDC, 0, 0, BYVAL VARPTR(zTxt), LEN(zTxt), _
                        GetSystemMetrics(%SM_CYCAPTION) + 4, y, _
                        @lpdis.rcItem.nRight, @lpdis.rcItem.nBottom, TextDrawFlag

              'GET/DRAW ICON
              hcIco = SendMessage(hWnd, %CB_GETITEMDATA, @lpdis.itemID, 0)
              IF hcIco THEN
                 IF (@lpdis.itemState AND &H1000) THEN 'if to draw %ODS_COMBOBOXEDIT (= &H1000)
                    DrawState @lpdis.hDC, 0, 0, hcIco, 0, _
                              5, @lpdis.rcItem.ntop + 1, 0, 0, IconDrawFlag
                 ELSE
                    DrawState @lpdis.hDC, 0, 0, hcIco, 0, _
                              3, @lpdis.rcItem.ntop + 2, 0, 0, IconDrawFlag
                 END IF
              END IF

              'FOCUS RECT AROUND SELECTED ITEM IN LIST
              IF (@lpdis.itemState AND %ODS_SELECTED) THEN  'if selected
                 DrawFocusRect @lpdis.hDC, @lpdis.rcItem    'draw a focus rectangle around all
              END IF

        END SELECT
        FUNCTION = %TRUE : EXIT FUNCTION

  END SELECT

  FUNCTION = CallWindowProc(oldCBFileTypeProc, hWnd, wMsg, wParam, lParam) 'process other messages
END FUNCTION
