'
' PBDIR include file - Public Domain by Borje Hagsten, January 2002.
' Totally self-containing via container window.
' Custom messages for some settings provided. Single-click select
' is special for my own needs - just ignore what you don't need..
'
' LOG:
' Jan 14, 2003: Changed handles to DWORD and now use GetSystemMetrics
'               to ensure item height = small icon if big font is set.
'               It now uses GetWindowLong(hWnd, %GWL_HINSTANCE) to
'               get proper instance handle at creation.
'
%DCM_SETDIRFILECTL   = %WM_USER + 5000 ' tell what File list control is attached to dir list
%DCM_SETDIRFTYPECTL  = %WM_USER + 5001 ' tell what File type control is attached to File list
%DCM_SETDIRSEL3DFACE = %WM_USER + 5002 ' wParam sets custom sel color, lParam decides redraw
%DCM_SETDIRSELTYPE   = %WM_USER + 5003 ' set selection behaviour - double or single click
%DCM_SETDIRS         = %WM_USER + 5004 ' is passed on to DirsToList - lParam is pointer to path
%DCM_GETDIRPATH      = %WM_USER + 5010 ' return value is pointer to asciiz string holding current path
'--------------------------------------------------------------------
TYPE PBDIRCTLDATA
  hFile      AS DWORD
  oldProc    AS DWORD
  sel3Dface  AS LONG
  selType    AS LONG
  curPath    AS ASCIIZ * %MAX_PATH
END TYPE
'--------------------------------------------------------------------
DECLARE FUNCTION PBDirExist(BYVAL sfName AS STRING) AS LONG
DECLARE FUNCTION PBDirPath (BYVAL hDlg AS DWORD, BYVAL DriveId AS DWORD, _
                            BYVAL sPBDrivePath AS STRING) AS STRING
DECLARE FUNCTION PBDirProc(BYVAL hWnd AS DWORD, BYVAL wMsg AS DWORD, _
                           BYVAL wParam AS LONG, BYVAL lParam AS LONG) AS LONG
DECLARE SUB DirsToList(BYVAL hWnd AS DWORD, BYVAL AbsPath AS STRING)

'
' Create DIR listbox control
'
FUNCTION CreatePBDirLB ALIAS "CreatePBDirLB" _
                      (BYVAL hWnd AS DWORD, BYVAL CtrlId AS LONG, _
                       BYVAL vLeft AS LONG, BYVAL vTop AS LONG, _
                       BYVAL vWidth AS LONG, BYVAL vHeight AS LONG, _
                       BYVAL DDTstyle AS LONG, BYVAL cDir AS STRING) EXPORT AS DWORD

  LOCAL hParent AS DWORD, hDirLst AS DWORD, cbFont AS DWORD, itemH AS LONG, rc AS RECT
  LOCAL wc AS WNDCLASSEX, szClassName AS ASCIIZ * 20, pdd AS PBDIRCTLDATA PTR

  'REGISTER A CUSTOM CONTROL CLASS FOR CONTAINER WINDOW
  szClassName      = "PBDIRX"
  wc.cbSize        = LEN(wc)
  wc.lpfnWndProc   = CODEPTR(PBDirMainProc)
  wc.cbWndExtra    = 4
  wc.hInstance     = GetWindowLong(hWnd, %GWL_HINSTANCE)
  wc.lpszClassName = VARPTR(szClassName)

  RegisterClassEx wc

  IF DDTstyle THEN
     DIALOG UNITS hWnd, vLeft, vTop TO PIXELS vLeft, vTop
     DIALOG UNITS hWnd, vWidth, vHeight TO PIXELS vWidth, vHeight
  END IF

  'CREATE CONTAINER WINDOW, for redrawing operations in WM_DRAWITEM
  hParent = CreateWindowEx(0, "PBDIRX", BYVAL 0, %WS_VISIBLE OR %WS_CHILD OR %WS_TABSTOP, _
                           vLeft, vTop, vWidth, vHeight, _
                           hwnd, CtrlId, wc.hInstance, BYVAL 0)

  IF hParent THEN 'CREATE OWNERDRAWN LISTBOX
     hDirLst = CreateWindowEx(%WS_EX_CLIENTEDGE, "LISTBOX", BYVAL 0, %WS_CHILD OR _
                             %WS_VISIBLE OR %LBS_OWNERDRAWFIXED OR %LBS_HASSTRINGS OR _
                             %LBS_NOTIFY OR %WS_TABSTOP OR %WS_VSCROLL, _
                             0, 0, vWidth, vHeight, _
                             hParent, CtrlId, wc.hInstance, BYVAL 0)
  ELSE
     EXIT FUNCTION 'return zero on failure
  END IF

  IF hDirLst THEN
     pdd = HeapAlloc(GetProcessHeap(), %HEAP_ZERO_MEMORY, SIZEOF(@pdd))
     IF pdd THEN 'store pointer to memory for UDT in parent's cbWndExtra
        SetWindowLong hParent, 0, pdd
      ELSE
        EXIT FUNCTION
     END IF

     'set standard Windows font
     cbFont = GetStockObject(%ANSI_VAR_FONT)
     IF cbFont THEN SendMessage hDirLst, %WM_SETFONT, cbFont, 0

     'ensure item height is at least small icon (caption icon) height
     itemH = GetSystemMetrics(%SM_CYSMICON)
     SendMessage hDirLst, %LB_SETITEMHEIGHT, 0, itemH  'adjust item height

     GetWindowRect hDirLst, rc 'resize parent to actual listbox size
     SetWindowPos hParent, 0, 0, 0, rc.nRight - rc.nLeft, _
                   rc.nBottom - rc.nTop + 1, %SWP_NOMOVE OR %SWP_NOZORDER

     'Subclass control and store pointer to old procedure at cbWndExtra's beginning.
     @pdd.oldProc = SetWindowLong(hDirLst, %GWL_WNDPROC, BYVAL CODEPTR(PBDirProc))

     IF cDir = "" THEN cDir = CURDIR$
     DirsToList hDirLst, cDir
  END IF

  FUNCTION = hDirLst 'return the control's handle
END FUNCTION

'
' Container procedure
'
FUNCTION PBDirMainProc(BYVAL hWnd   AS DWORD, BYVAL wMsg   AS DWORD,_
                       BYVAL wParam AS LONG, BYVAL lParam AS LONG) AS LONG

  LOCAL hDir AS DWORD, newPath AS STRING, pdd AS PBDIRCTLDATA PTR

  SELECT CASE wMsg
     CASE %WM_SETFOCUS
        SetFocus GetWindow(hWnd, %GW_CHILD)  'Move focus to next control
        FUNCTION = 0 : EXIT FUNCTION

     CASE %WM_CTLCOLORLISTBOX 'set appropriate background color to list
        IF IsWindowEnabled(GetWindow(hWnd, %GW_CHILD)) THEN
           FUNCTION = GetSysColorBrush(%COLOR_WINDOW)
        ELSE
           FUNCTION = GetSysColorBrush(%COLOR_3DFACE)
        END IF
        EXIT FUNCTION

     CASE %WM_DESTROY 'Un-subclass listbox when it's detroyed
        pdd = GetWindowLong(hWnd, 0)    'Get stored data
        IF @pdd.oldProc THEN SetWindowLong GetWindow(hWnd, %GW_CHILD), %GWL_WNDPROC, @pdd.oldProc
        HeapFree GetProcessHeap(), 0, BYVAL pdd  'free memory
        FUNCTION = 0 : EXIT FUNCTION

     CASE %WM_DRAWITEM 'pass on to control
        SendMessage GetDlgItem(hWnd, wParam), wMsg, wParam, lParam
        FUNCTION = %TRUE : EXIT FUNCTION

     CASE %WM_COMMAND  'pass these on to container's parent
        hDir = GetWindow(hWnd, %GW_CHILD)
        IF hDir AND HIWRD(wParam) = %LBN_DBLCLK THEN
           pdd = GetWindowLong(hWnd, 0) 'Get stored data
           newPath = PBDirPath(GetParent(hWnd), LOWRD(wParam), "")
           CHDIR newPath

           DirsToList hDir, newPath
           IF @pdd.hFile THEN        '%DCM_SETFILES
              SendMessage @pdd.hFile, %WM_USER + 6004, 0, BYVAL STRPTR(newPath)
           END IF
        END IF

        SendMessage GetParent(hWnd), wMsg, wParam, hDir 'lParam
        FUNCTION = 0 : EXIT FUNCTION

  END SELECT
  FUNCTION = DefWindowProc(hWnd, wMsg, wParam, lParam) 'default message processing
END FUNCTION

'
' Subclassed control's procedure
'
FUNCTION PBDirProc(BYVAL hWnd AS DWORD, BYVAL wMsg AS DWORD, _
                    BYVAL wParam AS LONG, BYVAL lParam AS LONG) AS LONG

  LOCAL hDC AS DWORD, iMsg AS DWORD, pMsg AS TAGMSG PTR,  _
        zpStr AS ASCIIZ PTR, pdd AS PBDIRCTLDATA PTR, rc AS RECT
  pdd = GetWindowLong(GetParent(hWnd), 0) 'Get stored data

  SELECT CASE wMsg
     CASE %DCM_SETDIRFILECTL 'set associated file control
        @pdd.hFile = wParam

     CASE %DCM_SETDIRSEL3DFACE 'select selection color scheme
        @pdd.sel3Dface = wParam
        IF lParam THEN
           InvalidateRect hWnd, BYVAL %NULL, 0
           UpdateWindow hWnd
        END IF

     CASE %DCM_SETDIRSELTYPE 'set selection behaviour - double or single click
        @pdd.selType = wParam

     CASE %DCM_GETDIRPATH '(%WM_USER + 5010)
        @pdd.curPath = PBDirPath(GetParent(GetParent(hWnd)), GetDlgCtrlId(hWnd), "")
        FUNCTION = VARPTR(@pdd.curPath)
        EXIT FUNCTION

     CASE %DCM_SETDIRS '(%WM_USER + 5004)
        IF lParam THEN
           zpStr = lParam
           IF LEN(@zpStr) THEN
              DirsToList hWnd, @zpStr
              IF @pdd.hFile THEN        '%DCM_SETFILES
                 SendMessage @pdd.hFile, %WM_USER + 6004, 0, zpStr
              END IF
           END IF
        END IF

     CASE %WM_ENABLE 'need to redraw whole list background
        GetClientRect hWnd, rc
        hDC = GetDc( hWnd)
        IF wParam THEN
           FillRect hDC, rc, GetSysColorBrush(%COLOR_WINDOW) 'clear whole background
        ELSE
           FillRect hDC, rc, GetSysColorBrush(%COLOR_3DFACE) 'clear whole background
        END IF
        ReleaseDc hWnd, hDC

     CASE %WM_GETDLGCODE
        pMsg = lParam
        IF pMsg THEN iMsg = @pMsg.Message
        IF iMsg = %WM_KEYDOWN THEN 'all we want to handle is the Enter key, so..
           SELECT CASE @pMsg.wParam
              CASE %VK_RETURN
                 FUNCTION = %DLGC_WANTALLKEYS : EXIT FUNCTION
           END SELECT
        END IF

     CASE %WM_KEYDOWN      'respond to keyboard input
        SELECT CASE wParam
           CASE %VK_RETURN 'Enter key - simulate double-click..
              SendMessage GetParent(hWnd), %WM_COMMAND, _
                          MAKLNG(GetDlgCtrlID(hWnd), %LBN_DBLCLK), hWnd
              FUNCTION = 0 : EXIT FUNCTION
        END SELECT

     CASE %WM_LBUTTONUP
        IF @pdd.selType = 1 THEN 'special - respond on single-clicks
           SendMessage GetParent(hWnd), %WM_COMMAND, _
                       MAKLNG(GetDlgCtrlID(hWnd), %LBN_DBLCLK), hWnd
        END IF

     CASE %WM_DRAWITEM      'Ownerdrawn = owner draws all items self (programmer = owner)
        LOCAL lpdis  AS DRAWITEMSTRUCT PTR
        lpdis = lParam
        IF @lpdis.itemID = &HFFFFFFFF& THEN EXIT FUNCTION 'empty list, so exit

        SELECT CASE @lpdis.itemAction
           CASE %ODA_DRAWENTIRE, %ODA_SELECT
              LOCAL itd AS LONG, xPos AS LONG, pos AS LONG, y AS LONG, _
                    TextDrawFlag AS LONG, IconDrawFlag AS LONG, _
                    tm AS TEXTMETRIC, lpshfi AS SHFILEINFO, zTxt AS ASCIIZ * %MAX_PATH

              TextDrawFlag = &H2  ' DST_PREFIXTEXT
              IconDrawFlag = &H3  ' DST_ICON

              'CLEAR BACKGROUND
              IF IsWindowEnabled(hWnd) THEN                                  'ENABLED CONTROL
                 IF (@lpdis.itemState AND %ODS_SELECTED) = 0 THEN            'if not selected
                    FillRect @lpdis.hDC, @lpdis.rcItem, GetSysColorBrush(%COLOR_WINDOW) 'clear background
                    SetBkColor @lpdis.hDC, GetSysColor(%COLOR_WINDOW)        'text background
                    SetTextColor @lpdis.hDC, GetSysColor(%COLOR_WINDOWTEXT)  'text color
                 ELSE
                    IF @pdd.sel3Dface THEN 'control is set to use custom sel color
                       FillRect @lpdis.hDC, @lpdis.rcItem, GetSysColorBrush(%COLOR_3DFACE) 'clear background
                       SetBkColor @lpdis.hDC, GetSysColor(%COLOR_3DFACE)     'text background
                       SetTextColor @lpdis.hDC, GetSysColor(%COLOR_BTNTEXT)  'text color
                    ELSE
                       FillRect @lpdis.hDC, @lpdis.rcItem, GetSysColorBrush(%COLOR_HIGHLIGHT) 'clear background
                       SetBkColor @lpdis.hDC, GetSysColor(%COLOR_HIGHLIGHT)        'text background
                       SetTextColor @lpdis.hDC, GetSysColor(%COLOR_HIGHLIGHTTEXT)  'text color
                    END IF
                 END IF
              ELSE                                                        'DISABLED CONTROL
                 FillRect @lpdis.hDC, @lpdis.rcItem, GetSysColorBrush(%COLOR_3DFACE) 'clear item background
                 SetBkColor @lpdis.hDC, GetSysColor(%COLOR_3DFACE)        'text background
                 SetTextColor @lpdis.hDC, GetSysColor(%COLOR_WINDOWTEXT)  'text color
                 TextDrawFlag = TextDrawFlag OR &H20 ' DSS_DISABLED
                 IconDrawFlag = IconDrawFlag OR &H20 ' DSS_DISABLED
              END IF

              'GET ITEM'S TEXT AND CALCULATE X POSITION
              SendMessage hWnd, %LB_GETTEXT, @lpdis.itemID, VARPTR(zTxt) 'Get selected text
              '----------------------------------------------------------------
              ' following routine makes sure path exists and list is updated if
              ' a listed folder name was changed by another program.
              '----------------------------------------------------------------
              IF @lpdis.itemID > 0 THEN
                 IF PBDirExist(zTxt) = 0 THEN
                    DO
                       pos = INSTR(-1, zTxt, ANY "\/")
                       IF pos > 3 THEN
                          zTxt = LEFT$(zTxt, pos - 1)
                          IF PBDirExist(zTxt) THEN
                             DirsToList hWnd, zTxt
                             EXIT FUNCTION
                          END IF
                       ELSE
                          DirsToList hWnd, LEFT$(zTxt, 3)
                          EXIT FUNCTION
                       END IF
                    LOOP
                 END IF
              END IF
              '----------------------------------------------------------------
              itd = SendMessage(hWnd, %LB_GETITEMDATA, @lpdis.itemID, 0)
              xPos = (TALLY(zTxt, "\") + itd - 1) * 5 + 3 ' x-distance between opened folders

              'GET SMALL ASSOCIATED ICON AND TEXT TO DISPLAY
              IF itd <> 1 THEN
                 SHGetFileInfo zTxt, 0, lpshfi, LEN(lpshfi), _
                               %SHGFI_DISPLAYNAME OR %SHGFI_ICON OR %SHGFI_SMALLICON
              ELSE
                 SHGetFileInfo zTxt, 0, lpshfi, LEN(lpshfi), _
                               %SHGFI_DISPLAYNAME OR %SHGFI_ICON OR %SHGFI_SMALLICON OR %SHGFI_OPENICON
              END IF

              'CALCULATE CENTERED Y POS FOR TEXT
              GetTextMetrics @lpdis.hDC, tm  'get font size
              y = (@lpdis.rcItem.nBottom + @lpdis.rcItem.nTop - tm.tmHeight) / 2 'center text

              'DRAW TEXT
              IF @lpdis.itemID = 0 THEN lpshfi.szDisplayName = UCASE$(zTxt)   'First item, drive, UCASE
              DrawState @lpdis.hDC, 0, 0, BYVAL VARPTR(lpshfi.szDisplayName), _
                        LEN(lpshfi.szDisplayName), _
                        xPos + GetSystemMetrics(%SM_CYCAPTION), y, _
                        @lpdis.rcItem.nRight, @lpdis.rcItem.nBottom, TextDrawFlag

              'DRAW ASSOCIATED ICON
              IF lpshfi.hIcon THEN
                 DrawState @lpdis.hDC, 0, 0, lpshfi.hIcon, 0, _
                           xPos, @lpdis.rcItem.ntop, 0, 0, IconDrawFlag
              END IF

           CASE %ODA_FOCUS
              DrawFocusRect @lpdis.hDC, @lpdis.rcItem 'draw focus rectangle

        END SELECT
        FUNCTION = %TRUE : EXIT FUNCTION

  END SELECT

  FUNCTION = CallWindowProc(@pdd.oldProc, hWnd, wMsg, wParam, lParam) 'process other messages
END FUNCTION

'
' FileExist - make sure a file or folder exists
'
FUNCTION PBDirExist(BYVAL sfName AS STRING) AS LONG
  LOCAL hRes AS DWORD, tWFD AS WIN32_FIND_DATA

  IF ASC(sfName, -1) = 92 THEN                'if a path with trailing backslash
     sfName = LEFT$(sfName, LEN(sfName) - 1)  'remove trailing backslash
  END IF

  hRes = FindFirstFile(BYVAL STRPTR(sfName), tWFD)
  IF hRes <> %INVALID_HANDLE_VALUE THEN
     FUNCTION = %TRUE
     FindClose hRes
  END IF
END FUNCTION

'
' Populate Listbox with available directories
'
SUB DirsToList(BYVAL hWnd AS DWORD, BYVAL AbsPath AS STRING)
  LOCAL ii AS LONG, jj AS LONG, hSearch AS DWORD, dc AS LONG, rc AS RECT
  LOCAL Path AS STRING, s AS STRING, arr() AS STRING, dWFD AS WIN32_FIND_DATA

  LOCAL pdd AS PBDIRCTLDATA PTR
  pdd = GetWindowLong(GetParent(hWnd), 0) 'Get stored data

  IF RIGHT$(AbsPath, 1) <> "\" THEN AbsPath = AbsPath & "\"
  @pdd.curPath = AbsPath 'store current path
  Path = AbsPath
  AbsPath = AbsPath + "*"

  FOR ii = 1 TO PARSECOUNT(Path, "\") - 1             'Parse and add dirs to array
     s = s + PARSE$(Path, "\", ii)
     IF LEN(s) THEN
        REDIM PRESERVE arr(dc)
        IF RIGHT$(s, 1) <> "\" THEN s = s & "\"
        arr(dc) = s
        INCR dc
     END IF
  NEXT ii
  jj = dc - 1

  hSearch = FindFirstFile(BYVAL STRPTR(AbsPath), dWFD) 'Loop through directory
  IF hSearch <> %INVALID_HANDLE_VALUE THEN
     DO
        IF (dWFD.dwFileAttributes AND 16) AND (dWFD.dwFileAttributes AND 4) = 0 THEN 'dirs, but not hidden..
           IF dWFD.cFileName <> "." AND dWFD.cFileName <> ".." THEN 'not these..
              AbsPath = EXTRACT$(dWFD.cFileName, CHR$(0))
              REDIM PRESERVE arr(dc)
              arr(dc) = Path + AbsPath
              INCR dc
            END IF
        END IF
     LOOP WHILE FindNextFile(hSearch, dWFD) ' Get next
     FindClose hSearch
  ELSE
     EXIT SUB
  END IF

  ARRAY SORT arr(jj), COLLATE UCASE 'sort not opened folders (those from jj and up)

  SendMessage hWnd, %LB_RESETCONTENT, 0, 0      'clear list
  FOR ii = 0 TO UBOUND(arr)
     SendMessage hWnd, %LB_ADDSTRING, 0, BYVAL STRPTR(arr(ii))
     IF ii = 0 THEN
        SendMessage hWnd, %LB_SETITEMDATA, ii, 0 'is drive
     ELSEIF ii = < jj THEN
        SendMessage hWnd, %LB_SETITEMDATA, ii, 1 'opened folders
     ELSE
        SendMessage hWnd, %LB_SETITEMDATA, ii, 2 'closed folders
     END IF
  NEXT
  SendMessage hWnd, %LB_SELECTSTRING, -1, BYVAL STRPTR(Path)

  'adjust topindex when bottom item opens up and contains children
  ii = SendMessage(hWnd, %LB_GETCURSEL, 0, 0)
  IF ii > %LB_ERR THEN
     jj = SendMessage(hWnd, %LB_GETITEMHEIGHT, 0, 0)
     IF jj > 0 THEN
        GetClientRect hWnd, rc
        jj = rc.nBottom \ jj
        dc = SendMessage(hWnd, %LB_GETCOUNT, 0, 0)
        IF jj > 2 AND dc > jj THEN
           IF ii - SendMessage(hWnd, %LB_GETTOPINDEX, 0, 0) = jj -1 THEN _
              SendMessage hWnd, %LB_SETTOPINDEX, ii - 1, 0
        END IF
     END IF
  END IF

END SUB

'
' Return or set dir control's path
'
FUNCTION PBDirPath (BYVAL hDlg AS DWORD, BYVAL DirId AS DWORD, BYVAL sPBDirPath AS STRING) AS STRING
  LOCAL hWnd AS DWORD, cLen AS LONG, cSel AS LONG

  hWnd = GetDlgItem(GetDlgItem(hDlg, DirId), DirId) 'list is child of container
  IF LEN(sPBDirPath) THEN 'set path
     SendMessage hWnd, %LB_SELECTSTRING, -1, BYVAL STRPTR(sPBDirPath)
  END IF

  cSel = SendMessage(hWnd, %LB_GETCURSEL, 0, 0)
  IF cSel <> %LB_ERR THEN
     cLen = SendMessage(hWnd, %LB_GETTEXTLEN, cSel, 0)
     sPBDirPath = SPACE$(cLen)
     SendMessage hWnd, %LB_GETTEXT, cSel, STRPTR(sPBDirPath)
     IF RIGHT$(sPBDirPath, 1) <> "\" THEN sPBDirPath = sPBDirPath & "\"
  END IF

  FUNCTION = sPBDirPath
END FUNCTION
