'
' Path dialog sample, using the PB_DRIVE and PB_DIR controls.
' Public Domain by Borje Hagsten, August 14, 2003
'
' Declares
'--------------------------------------------------------------------
#COMPILE EXE
#INCLUDE "WIN32API.INC"
#INCLUDE "PBDRIVE.INC"
#INCLUDE "PBDIR.INC"
'--------------------------------------------------------------------
GLOBAL gsPath AS STRING
'--------------------------------------------------------------------
%IDC_MAIN_LABEL1 = 111
%IDC_MAIN_LABEL2 = 112

%IDC_PATH_LABEL1 = 211
%IDC_PATH_LABEL2 = 212
%IDC_PATH_LABEL3 = 213
%IDC_PATH_DRIVE1 = 230
%IDC_PATH_DIR1   = 240
'--------------------------------------------------------------------
DECLARE CALLBACK FUNCTION DlgProc() AS LONG
DECLARE CALLBACK FUNCTION GetNewPathProc() AS LONG
DECLARE FUNCTION GetNewPath (BYVAL hParent AS LONG, BYVAL path AS STRING) AS LONG
DECLARE SUB CompactPathToLabel(BYVAL hDlg AS LONG, BYVAL idLabel AS LONG, BYVAL path AS STRING)

'
' Main dialog's entrance
'--------------------------------------------------------------------
FUNCTION PBMAIN () AS LONG
  LOCAL hDlg AS DWORD
 
  DIALOG NEW 0, "Main dialog",,, 240, 120, %WS_CAPTION OR %WS_SYSMENU, 0 TO hDlg
 
  CONTROL ADD LABEL, hDlg, %IDC_MAIN_LABEL1, "Path:", 20, 50,  30, 10
  CONTROL ADD LABEL, hDlg, %IDC_MAIN_LABEL2, "",      50, 50, 180, 10

  CONTROL ADD BUTTON, hDlg, %IDOK, "&Path", 132, 102, 50, 14
  CONTROL ADD BUTTON, hDlg, %IDCANCEL, "&Quit", 186, 102, 50, 14
 
  DIALOG SHOW MODAL hDlg CALL DlgProc
 
END FUNCTION
 
'
' Main dialog's callback
'--------------------------------------------------------------------
CALLBACK FUNCTION DlgProc() AS LONG

  SELECT CASE CBMSG
     CASE %WM_INITDIALOG   ' can initiate variables and controls, etc. here
        gsPath = CURDIR$   ' start with some path..
        CONTROL SET TEXT CBHNDL, %IDC_MAIN_LABEL2, gsPath
 
     CASE %WM_COMMAND      ' a control is calling
        SELECT CASE CBCTL  ' look at control's id
           CASE %IDOK
              IF CBCTLMSG = %BN_CLICKED OR CBCTLMSG = 1 THEN
                 IF GetNewPath(CBHNDL, gsPath) THEN
                    CONTROL SET TEXT CBHNDL, %IDC_MAIN_LABEL2, gsPath
                 END IF
              END IF
 
           CASE %IDCANCEL
              IF CBCTLMSG = %BN_CLICKED OR CBCTLMSG = 1 THEN 'end prog
                 DIALOG END CBHNDL
              END IF
        END SELECT

     CASE %WM_NCACTIVATE 'is sent when a dialog gets/looses focus
         STATIC hOldFocus AS DWORD
         IF CBWPARAM = 0 THEN        'if dialog is loosing focus
             hOldFocus = GetFocus()  'store handle of control in focus
         ELSEIF hOldFocus THEN       'if dialog gets focus and we have
             SetFocus hOldFocus      'old control handle, reset focus
             hOldFocus = 0           'and clear variable
         END IF

  END SELECT
END FUNCTION

'
' Path dialog's entrance
'--------------------------------------------------------------------
FUNCTION GetNewPath (BYVAL hParent AS LONG, BYVAL sPath AS STRING) AS LONG
  LOCAL hDlg AS DWORD, hDrive AS DWORD, hDir AS DWORD, lRes AS LONG

  DIALOG NEW hParent, "Select Path" ,,, 160, 153, _
             %WS_POPUP OR %DS_MODALFRAME OR %WS_CAPTION OR %WS_SYSMENU, 0 TO hDlg

  SetCurrentDirectory BYVAL STRPTR(sPath) 'test if given path exists
  IF GetLastError THEN sPath = CURDIR$    'if system error, it didn't ..

  CONTROL ADD LABEL, hDlg, %IDC_PATH_LABEL2,  "Unit:",   6, 106,  80,   9
  hDrive = CreatePBDriveCB(hDlg, %IDC_PATH_DRIVE1, 5, 115, 150,  70, 1, LEFT$(sPath, 3))
  CONTROL ADD LABEL, hDlg, %IDC_PATH_LABEL1,  "Folder:", 6,   2,  26,   9
  CONTROL ADD LABEL, hDlg, %IDC_PATH_LABEL3,  "", 32,  2, 124,   9
  hDir = CreatePBDirLB(hDlg, %IDC_PATH_DIR1, 5,  11, 150, 95, %TRUE, sPath)

  SendMessage hDrive, %DCM_SETDRVDIRCTL, hDir, 0   'attach dir ctrl to drive ctrl
  CompactPathToLabel hDlg, %IDC_PATH_LABEL3, sPath 'show initial path

   SendMessage hDir, %DCM_SETDIRSELTYPE, 1, 0  'for single-click sel mode

  CHDRIVE LEFT$(sPath, 2)
  CHDIR sPath
  CALL DirsToList(hDir, sPath)

  CONTROL ADD BUTTON, hDlg, %IDOK,     "&Ok",      53, 135, 50, 14
  CONTROL ADD BUTTON, hDlg, %IDCANCEL, "&Cancel", 105, 135, 50, 14

  DIALOG SHOW MODAL hDlg, CALL GetNewPathProc TO lRes

  FUNCTION = lRes
END FUNCTION

'
' Path dialog's callback
'
CALLBACK FUNCTION GetNewPathProc() AS LONG
  LOCAL sPath AS STRING

  SELECT CASE CBMSG
     CASE %WM_COMMAND
        SELECT CASE CBCTL
           CASE %IDOK  'set global path string and return %TRUE on Ok
              IF CBCTLMSG = %BN_CLICKED OR CBCTLMSG = 1 THEN
                 gsPath = PBDirPath(CBHNDL, %IDC_PATH_DIR1, "")
                 DIALOG END CBHNDL, %TRUE
              END IF

           CASE %IDCANCEL  'return %FALSE on Cancel
              IF CBCTLMSG = %BN_CLICKED OR CBCTLMSG = 1 THEN
                 DIALOG END CBHNDL, %FALSE
              END IF

           CASE %IDC_PATH_DIR1 'DIR LISTBOX
              IF CBCTLMSG = %LBN_SELCHANGE THEN
                 sPath = PBDirPath(CBHNDL, %IDC_PATH_DIR1, "")
                 CompactPathToLabel CBHNDL, %IDC_PATH_LABEL3, sPath
                 CHDIR sPath
              END IF

           CASE %IDC_PATH_DRIVE1 'DRIVE COMBO
              IF CBCTLMSG = %CBN_SELENDOK THEN
                 sPath = PBDrivePath(CBHNDL, %IDC_PATH_DRIVE1, "")
                 CompactPathToLabel CBHNDL, %IDC_PATH_LABEL3, sPath
                 CHDRIVE LEFT$(sPath, 2)
                 CHDIR sPath
              END IF
        END SELECT

     CASE %WM_NCACTIVATE 'is sent when a dialog gets/looses focus
         STATIC hOldFocus AS DWORD
         IF CBWPARAM = 0 THEN        'if dialog is loosing focus
             hOldFocus = GetFocus()  'store handle of control in focus
         ELSEIF hOldFocus THEN       'if dialog gets focus and we have
             SetFocus hOldFocus      'old control handle, reset focus
             hOldFocus = 0           'and clear variable
         END IF

  END SELECT
END FUNCTION

'
' Make given path fit into a label control via %DT_PATH_ELLIPSIS.
' Other ways exists, but this one works in all systems - Win95 and up.
'--------------------------------------------------------------------
SUB CompactPathToLabel(BYVAL hDlg AS DWORD, BYVAL idLabel AS LONG, BYVAL path AS STRING)
  LOCAL hDC AS DWORD, hFont AS DWORD, hLabel AS DWORD, rc AS RECT

  hLabel = GetDlgItem(hDlg, idLabel)
  hFont  = SendMessage(hLabel, %WM_GETFONT, 0, 0)
  GetClientRect hLabel, rc

  hDC = GetDC(hLabel)
  hFont = SelectObject(hDC, hFont)
  DrawText hDC, BYVAL STRPTR(path), LEN(path), rc, _
           %DT_PATH_ELLIPSIS OR %DT_MODIFYSTRING
  SelectObject hDC, hFont
  ReleaseDc hLabel, hDc

  CONTROL SET TEXT hDlg, idLabel, path
END SUB

